<template lang="pug">
div
  .row
    q-banner.q-mb-lg.bg-orange.full-width.text-white(rounded)
      .row
        .col-12.col-md-6.text-body1 CAREFUL! Switching the phase will prevent any submissions in other phases for EVERYONE.
        .col-12.col-md-6.text-right
          q-btn-toggle.text-uppercase(
            v-model="config.current_phase",
            toggle-color="secondary",
            :options="phaseoptions",
            @input="savePhase"
          )

  .text-center(v-if="judgingStart()")
    q-btn.q-px-md.q-my-md(
      rounded,
      color="secondary",
      @click="startJudgingProgress",
      :label="$t('start_judging')"
    )

  .row 
    .col
      q-table.no-shadow.no-border(
        :data="submissions",
        :columns="submissionColumn",
        :loading="loading",
        row-key="submitted_by.uid",
        :pagination.sync="pagination",
        @request="onRequest"
      )
        template(v-slot:body-cell-linkedin="props")
          q-td(auto-width)
            q-avatar.on-left.text-white(
              square,
              color="blue",
              size="sm",
              v-if="props.row.submitted_by.uid.startsWith('linkedin')"
            ) LI
        template(v-slot:body-cell-submitted_by.user_name="props")
          q-td(auto-width)
            span {{ props.row.submitted_by.displayName }}
        template(v-slot:body-cell-submitted_by.email="props")
          q-td(auto-width)
            span {{ props.row.submitted_by.email }}
        template(v-slot:body-cell-region="props")
          q-td(auto-width) {{ codeToFlag(props.row.region) }}
            q-tooltip {{ codeToName(props.row.region) }}
        template(v-slot:body-cell-language="props")
          q-td(auto-width) {{ codeToLang(props.row.language) }} ({{ codeToLang(props.row.commslanguage) }})

        template(v-slot:body-cell-Submissions="props")
          q-td
            a(
              :key="sub.id",
              v-for="sub in props.row.submissions",
              target="_blank"
            )
              q-chip(:color="getChipColor(sub.status)") {{ sub.phase }}
              q-tooltip {{ sub.status }}
        template(v-slot:body-cell-Actions="props")
          q-td(auto-width)
            q-btn(icon="flag", flat, round, dense, disabled)
</template>

<script>
import { adminListSubmissions, db } from "@/db";
import { DateTime } from "luxon";
import regions from "@/ifrclist.json";
import langmap from "langmap";
import { mapState, mapActions } from "vuex";
import { find, map, filter, includes } from "lodash";

export default {
  components: {},
  computed: {
    phaseoptions() {
      if (!this.config.phases) return [];
      return map(filter(this.config.phases, "visible"), (m) => {
        return {
          value: m.code,
          label: this.$t("phase.phase_" + m.code),
        };
      });
    },
    ...mapState({
      user: (state) => state.user,
      judging: (state) => state.judging,
    }),
  },
  data: () => {
    return {
      pagination: {
        sortBy: "submitted_by.user_name",
        descending: true,
        page: 1,
        rowsPerPage: 20,
        rowsNumber: -1,
        judgeStarted: false,
      },
      config: {
        current_phase: -1,
      },
      loading: false,
      lastone: {},
      submissions: [],
      terms: {},
      submissionColumn: [
        {
          label: "",
          name: "linkedin",
          field: "linkedin",
          align: "left",
          sortable: false,
        },
        {
          label: "Contributor",
          name: "submitted_by.user_name",
          field: "submitted_by.user_name",
          align: "left",
          sortable: true,
        },
        {
          label: "Email",
          name: "submitted_by.email",
          field: "submitted_by.email",
          align: "left",
          sortable: false,
        },
        {
          label: "Last Touched",
          name: "lastTouched",
          align: "left",
          field: "lastTouched",
          sortable: true,
          format: (val) => {
            if (!val) return "-";
            else return `${DateTime.fromSeconds(val._seconds).toRelative()}`;
          },
          // format: (val) => `${DateTime.fromSeconds(val._seconds).toRelative()}`,
        },
        {
          label: "NS",
          name: "region",
          field: "region",
          align: "left",
          sortable: false,
        },
        {
          label: "Language (Comms)",
          name: "language",
          field: "language",
          align: "left",
          sortable: true,
        },
        {
          name: "Submissions",
          label: "Submissions",
          field: "submissions",
          sortable: false,
          align: "left",
        },

        // {
        //   name: "Actions",
        //   label: "Actions",
        //   sortable: false,
        //   align: "right",
        // },
      ],
    };
  },
  watch: {
    terms: {
      deep: true,
      // immediate:true,
      async handler() {},
    },
  },
  mounted() {
    this.onRequest({
      pagination: this.pagination,
    });
  },
  methods: {
    ...mapActions(["startJudging"]),
    async startJudgingProgress() {
      this.$q.loading.show({
        message: this.$t("waiting_judging"),
      });
      const error = await this.startJudging();
      this.$q.loading.hide();
      if (!error) {
        this.judgeStarted = true;
        this.$q.notify({
          type: "positive",
          message: this.$t("judging_success"),
        });
      } else
        this.$q.notify({
          type: "negative",
          message: this.$t("judging_error"),
        });
    },
    async savePhase() {
      try {
        await db.collection("config").doc("meta").update({
          current_phase: this.config.current_phase,
        });
      } catch (e) {
        this.showError(e);
      }
    },
    codeToName(val) {
      // console.log(val);
      if (!val) return "-";
      let f = find(regions, { code: val });
      if (!f) return val;
      return `${f.flag} ${f.name}`;
    },
    codeToFlag(val) {
      // console.log(val);
      if (!val) return "-";
      let f = find(regions, { code: val });
      if (!f) return val;
      return `${f.flag}`;
    },
    codeToLang(val) {
      if (!val) return "-";
      let l = langmap[val.toLowerCase()];
      return l ? l.englishName : val;
    },
    async onRequest(props) {
      this.loading = true;
      let tmp = (await adminListSubmissions(props)).data;

      if (this.pagination.rowsNumber == -1)
        this.pagination.rowsNumber = tmp.meta.total;

      this.pagination.page = tmp.meta.page;
      this.pagination.sortBy = tmp.meta.sortBy;
      this.pagination.descending = tmp.meta.descending;

      this.submissions = tmp.data;
      this.loading = false;
    },
    getChipColor(status) {
      if (status === "submitted") {
        return "warning";
      } else if (status === "readyformoderation") {
        return "grey";
      } else if (status === "moderated") {
        return "info";
      } else if (status === "rejected" || status == "error") {
        return "negative";
      } else if (
        status === "translated" ||
        status === "subtitled" ||
        status == "draft"
      ) {
        return "warning";
      } else if (status === "finalised" || status == "edited") {
        return "positive";
      } else {
        return "info";
      }
    },
    judgingStart() {
      if (!this.user) return false;
      return (
        includes(this.user.roles, "superadmin") &&
        this.judging &&
        !this.judgeStarted
      );
    },
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>

<style lang="sass"></style>
